function Ped22000_relatorios_customizaveis_pedidos_itens_Controller (ScreenService, General, ZHPromise, templateManager, ZhFilterPreferences) {
    

    this.setNameLayout = function(args){
        
        var widget = args.owner;
        if (!widget.hasOwnProperty('labelPrincipal')){
            widget.labelPrincipal = widget.label;
        }
        if (args.e.layout.ID == 'ORIGINAL'){
            widget.container.label = widget.labelPrincipal;
            widget.label = widget.labelPrincipal;
        }else{
            widget.container.label = args.e.layout.LABEL_TO_PREFERENCE;
            widget.label = args.e.layout.LABEL_TO_PREFERENCE;
        }
    };
    
    this.openFilter = function(widget) {
        
        var rowsToSet = {};
        var CDVENDEDOR_AUX ;
        var CDOPERADOR_AUX;
        
        rowsToSet.IDTPENDECLIE = 'P';

        this.getOperadorLogado().then(function(success) {
            
            CDOPERADOR_AUX = success.dataset.operador[0].CDOPERADOR;
            var filter = [
                {
                    "name": "CDOPERADOR",
                    "operator": "=",
                    "value": success.dataset.operador[0].CDOPERADOR
                }
            ];
            General.callRestEngine('ped#/crud/filial', 'FilterData', [{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function(response) {
                rowsToSet.NMFILIAL = response.dataset.filial[0].NMFILIAL;

                rowsToSet.CDFILIAL = response.dataset.filial[0].CDFILIAL;
                rowsToSet.NMTIPOCUSTO = "Custo Médio Líquido da Época";
                rowsToSet.CDTIPOCUSTO = "03";
                General.callRestEngine("ped#/crud/vendedor", 'FilterData', filter).then(function (success){
                
                    if(success.dataset.vendedor.length >0){
                    
                        rowsToSet.CDVENDEDOR = success.dataset.vendedor[0].CDVENDEDOR;
                        rowsToSet.NMFANVEN = success.dataset.vendedor[0].NMFANVEN;
                        if(templateManager.container.getWidget('widgetRelatorioCustomizavelPedidoItem').getField('CDVENDEDOR').IDUTRELACVENDCLI_AUX == 'S'){
                            if(rowsToSet){
                                this.setCliente_Vendedor(widget,rowsToSet,rowsToSet.CDVENDEDOR);
                            }
                        }
                        //this.setCliente_Vendedor(widget, rowsToSet, rowsToSet.CDVENDEDOR);
                    }
                    
                    rowsToSet.DTPEDIDO = this.getIntervaloDataFiltro();
                  
                  
                    var filter = [
                        {
                            "name": "CDFILIAL",
                            "operator": "=",
                            "value": "FILIAL_LOGADA"
                        }
                    ];
        
                    General.callRestEngine("ped#/crud/parampedido", 'FilterData', filter).then(function (success){
                        if(success.dataset.parampedido.length != 0 && success.dataset.parampedido[0].IDEXIBPEDIDO == '2'){
                            
                            var widget_aux = templateManager.container.getWidget('widgetRelatorioCustomizavelPedidoItem');
                            widget_aux.getField('CDVENDEDOR').IDUTRELACVENDCLI_AUX = rowsToSet.IDUTRELACVENDCLI = success.dataset.parampedido[0].IDUTRELACVENDCLI;
    
                            var filterFilial = [
                                {
                                    "name": "CDFILIAL",
                                    "operator": "=",
                                    "value": "FILIAL_LOGADA"
                                },
                                {
                                    "name": "IDAUTGRUPOP",
                                    "operator": "=",
                                    "value": "TPED"
                                }
                                
                            ];
                            
                            General.callRestEngine("ped#/crud/autgrupop", 'FilterData', filterFilial).then(function (success){
                                
                                if(success.dataset.autgrupop.length != 0){
                                    
                                    var filterOperador = [
                                        {
                                            "name": "CDGRUPOPER",
                                            "operator": "=",
                                            "value": success.dataset.autgrupop[0].CDGRUPOPER
                                        },
                                        {
                                            "name": "CDOPERADOR",
                                            "operator": "=",
                                            "value": CDOPERADOR_AUX
                                        }
                                    ];
                                    
                                    General.callRestEngine("ped#/crud/opergrupop", 'FilterData', filterOperador).then(function (success){
                                    
                                        if(success.dataset.opergrupop.length != 0){
                                            ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(function (){
                                               
                                                widget.container.getActiveWidget().getField('NMFANVEN').readOnly = false;
                                                widget.container.getActiveWidget().getField('NMFANVEN').readOnlyOnEdit = false;
                                           }.bind(this));
                                        }
                                    }.bind(this));
                                }
                                this.setVendedor(widget,rowsToSet , CDOPERADOR_AUX);
                            }.bind(this));
                        }else if(success.dataset.parampedido.length != 0 && success.dataset.parampedido[0].IDEXIBPEDIDO == '1'){
                            ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(function (){
                                               
                                widget.container.getActiveWidget().getField('NMFANVEN').readOnly = false;
                                widget.container.getActiveWidget().getField('NMFANVEN').readOnlyOnEdit = false;
                                widget.container.getActiveWidget().currentRow.NMFANVEN = '';
                                widget.container.getActiveWidget().currentRow.CDVENDEDOR = '';
    
                           }.bind(this));
                            this.setVendedor(widget, rowsToSet, CDOPERADOR_AUX);
                        } else {
                            ScreenService.showMessage('Não foi encontrada nenhuma parametrização para a Filial logada.');
                    }
                    }.bind(this));
                }.bind(this));
            }.bind(this));
        }.bind(this));
    };
    
    this.setNumPedido = function(){
        var widget = templateManager.container.getActiveWidget();
        var pedidoIni = widget.currentRow.NRPEDIDOINI;
        if(pedidoIni!= undefined && pedidoIni!= ""){
            widget.getField("NRPEDIDOFIM").readOnly = false;
            widget.getField("NRPEDIDOFIM").setValue(pedidoIni);
            widget.getField("NRPEDIDOFIM").reload();  
        }else{
            widget.getField("NRPEDIDOFIM").clearValue();
            widget.getField("NRPEDIDOFIM").readOnly = true;
            widget.getField("NRPEDIDOFIM").reload();
        }
    };
    /*global moment*/
    this.getIntervaloDataFiltro = function(){
        
        const startOfMonth = moment().startOf('month').format('DD/MM/YYYY');
        var today = moment().format('DD/MM/YYYY');
        
        var interval = {
            "end" : today,
            "period" : undefined,
            "start" : startOfMonth
        };
        
        return interval;
    };

    this.getOperadorLogado = function(){
        
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        
        return General.callRestEngine("ped#/crud/operador", 'FilterData', filter);
	};
	
    this.setCliente_Vendedor = function(widget,rowsToSet, CDVENDEDOR){
        
        var filterVendedor = [
            {
                "name": "CDVENDEDOR",
                "operator": "=",
                "value": CDVENDEDOR
            }
        ];
        
        General.callRestEngine("ped#/crud/cliente_vendedor", 'FilterData', filterVendedor).then(function (success){
            
            if(success.dataset.cliente_vendedor.length > 0 ){
                ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(function () {
                    
                    widget.container.getActiveWidget().getField('NMRAZSOCCLIE').dataSourceFilter = filterVendedor;
                    widget.container.getActiveWidget().currentRow.NMRAZSOCCLIE = '';
                    widget.container.getActiveWidget().getField('NMRAZSOCCLIE').reload();
                    
                }.bind(this));

            }else if(!rowsToSet.CDVENDEDOR && !(templateManager.container.getActiveWidget().getField('NMFANVEN').readOnly)){
                ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
            }
        
        }.bind(this));
        
    };
    
    this.disableSitPedido = function(){
        var filterWidget = templateManager.container.getActiveWidget();
        
        if(filterWidget.currentRow.NRNOTAFISC){
            filterWidget.getField('IDSITPEDIDO').clearValue();
            filterWidget.getField('IDSITPEDIDO').setValue(["3", "6"]);
            filterWidget.getField('IDSITPEDIDO').readOnly = true;
            
        }else{
            filterWidget.getField('IDSITPEDIDO').readOnly = false;
            filterWidget.getField('IDSITPEDIDO').clearValue();
        }
    };

    this.getFieldValue = function(filedName, widgetName, fromFilter = false) {
		try {
			var container = templateManager.container;
			if (container) {
				let valuesWidget = container.getWidget(widgetName);
				if (fromFilter) {
					valuesWidget = templateManager.container.factoredWidgets.filter((widget) => {return widget._filteredWidgetId == valuesWidget.id;})[0];
				}

				if (valuesWidget) {
					var valueField = valuesWidget.currentRow[filedName];
					return valueField || null;
				}
				else return null;
			}
			else return null;
		}
		catch (error) {
			return null;
		}
	};
	

    this.setDataSourceFilterApply = function(args){
        
        var valuesWidget = templateManager.container.factoredWidgets.filter((widget) => {return widget._filteredWidgetId == args.owner.id;});
        var rowPopup = valuesWidget[0].currentRow;
        var readonlyVendedor = valuesWidget[0].getField('NMFANVEN').readOnly;
        
        var dataSourceFilter = [];

        dataSourceFilter.push(
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": rowPopup.CDFILIAL
            },
            {
                "name": "DTPEDIDO",
                "operator": "BETWEEN",
                "value": [rowPopup.DTPEDIDO.start, rowPopup.DTPEDIDO.end]
            },
            {
                "name": "CDTIPOCUSTO",
                "operator": "=",
                "value": rowPopup.CDTIPOCUSTO
            }
            
        );
        
        if(rowPopup.DTEMISSAO != '' && rowPopup.DTEMISSAO != undefined){
            dataSourceFilter.push(
                {
                    "name": "DTEMISSAO",
                    "operator": "=",
                    "value": rowPopup.DTEMISSAO
                }
            );
        }
        if(rowPopup.DTENTITPED!= '' && rowPopup.DTENTITPED!= undefined){
            dataSourceFilter.push(
                {
                    "name": "DTENTITPED",
                    "operator": "=",
                    "value": rowPopup.DTENTITPED
                }
            );

        }else{
           dataSourceFilter.push(
                {
                    "name": "TDTENTIT",
                    "operator": "=",
                    "value": "T"
                }
            ); 
        }
        
        if(rowPopup.CDREGIAOPED!= '' && rowPopup.CDREGIAOPED!= undefined){
            dataSourceFilter.push(
                {
                    "name": "CDREGIAOPED",
                    "operator": "=",
                    "value": rowPopup.CDREGIAOPED
                }
            );

        }
        if(rowPopup.NRLANCTONF!= '' && rowPopup.NRLANCTONF!= undefined){
            dataSourceFilter.push(
                {
                    "name": "NRLANCTONF",
                    "operator": "=",
                    "value": rowPopup.NRLANCTONF
                }
            );

        }
        
        if(rowPopup.NMPRODINI != '' && rowPopup.NMPRODINI != undefined){
            
            dataSourceFilter.push(
                {
                    "name": "CDARVPROD",
                    "operator": "BETWEEN",
                    "value": [rowPopup.P_PRODINI, rowPopup.P_PRODFIN]
                }
            );
        }
        
        if(rowPopup.DTENTPED.start != ''){
            dataSourceFilter.push(
                {
                    "name": "DTENTPED",
                    "operator": "BETWEEN",
                    "value": [rowPopup.DTENTPED.start, rowPopup.DTENTPED.end]
                }
            );
        }
        
        if(rowPopup.IDSITPEDIDO !== undefined){
            if(rowPopup.IDSITPEDIDO.length != 0){
                dataSourceFilter.push(
                    {
                        "name": "IDSITPEDIDO",
                        "operator": "IN",
                        "value": rowPopup.IDSITPEDIDO
                    }
                );
            }
        }
        if(rowPopup.IDSITITEMPED !== undefined){
            if(rowPopup.IDSITITEMPED.length != 0){
                dataSourceFilter.push(
                    {
                        "name": "IDSITITEMPED",
                        "operator": "IN",
                        "value": rowPopup.IDSITITEMPED
                    }
                );
            }
        }
        
        if(rowPopup.IDPRIOPED != undefined){
            if(rowPopup.IDPRIOPED != null){ 
                dataSourceFilter.push(
                    {
                        "name": "IDPRIOPED",
                        "operator": "=",
                        "value": rowPopup.IDPRIOPED
                    }
                );
            }
        }
        
        if (rowPopup.CDVENDEDOR != undefined && rowPopup.CDVENDEDOR != ""){
            dataSourceFilter.push(
                {
                    "name": "CDVENDEDOR",
                    "operator": "=",
                    "value": rowPopup.CDVENDEDOR
                }
            );
            
        }
        
        if(rowPopup.CDFILIALPED != undefined){
            if(rowPopup.CDFILIALPED != '' ){
                dataSourceFilter.push(
                    {
                        "name": "CDFILIALPED",
                        "operator": "=",
                        "value": rowPopup.CDFILIALPED
                    }
                );
            }
        }
        
        if(rowPopup.CDPRECOBASE != undefined){
            if(rowPopup.CDPRECOBASE != '' ){
                dataSourceFilter.push(
                    {
                        "name": "CDPRECOBASE",
                        "operator": "=",
                        "value": rowPopup.CDPRECOBASE
                    }
                );
            }
        }
        
        if (rowPopup.CDTIPOOPER != undefined){
            if(rowPopup.CDTIPOOPER != ''){
                dataSourceFilter.push(
                    {
                        "name": "CDTIPOOPER",
                        "operator": "=",
                        "value": rowPopup.CDTIPOOPER
                    }
                );
            }
        }
        
        if(rowPopup.IDTIPOPEDIDO != undefined && rowPopup.IDTIPOPEDIDO != ""){
            dataSourceFilter.push(
                {
                    "name": "IDTIPOPEDIDO",
                    "operator": "IN",
                    "value": rowPopup.IDTIPOPEDIDO
                }
            );
        }
        
        if(rowPopup.IDORIGPED != undefined){
            if(rowPopup.IDORIGPED != null){
                dataSourceFilter.push(
                    {
                        "name": "IDORIGPED",
                        "operator": "=",
                        "value": rowPopup.IDORIGPED
                    }
                );
            }
        }
        
        if (rowPopup.NRORDEMCMPPED != undefined){
            if(rowPopup.NRORDEMCMPPED!= ''){
                dataSourceFilter.push(
                    {
                        "name": "NRORDEMCMPPED",
                        "operator": "=",
                        "value": rowPopup.NRORDEMCMPPED
                    }
                );
            }
            
        }
        if(rowPopup.NRLANCTONF == undefined && rowPopup.NRLANCTONF == ''){
            dataSourceFilter.push(
                {
                    "name": "NRLANCTONF",
                    "operator": "=",
                    "value": rowPopup.NRLANCTONF
                }
            );
            
        }
        
        if(rowPopup.NRNOTAFISC == undefined || rowPopup.NRNOTAFISC == ''){
            dataSourceFilter.push(
                {
                    "name": "TNOTA",
                    "operator": "=",
                    "value": "T"
                }
            );
            
        }else if(rowPopup.NRNOTAFISC != undefined){
            if(rowPopup.NRNOTAFISC != ''){
                dataSourceFilter.push(
                    {
                        "name": "NRNOTAFISC",
                        "operator": "=",
                        "value": rowPopup.NRNOTAFISC
                    }
                );
            }
        }

        if(rowPopup.NRPEDIDOINI != rowPopup.NRPEDIDOFIM){
            dataSourceFilter.push(
                {
                    "name": "NRPEDIDO",
                    "operator": "BETWEEN",
                    "value": [rowPopup.NRPEDIDOINI, rowPopup.NRPEDIDOFIM]
                }
            );

        }else if(rowPopup.NRPEDIDOINI == rowPopup.NRPEDIDOFIM &&  rowPopup.NRPEDIDOINI != undefined){
            if(rowPopup.NRPEDIDOINI != ''){
                dataSourceFilter.push(
                {
                    "name": "NRPEDIDO",
                    "operator": "=",
                    "value": rowPopup.NRPEDIDOINI
                } 
            );
            }
        }
        
        if(rowPopup.CDCLIENTE != undefined){
            if(rowPopup.CDCLIENTE != ''){
                dataSourceFilter.push(
                    {
                        "name": "CDCLIENTE",
                        "operator": "=",
                        "value": rowPopup.CDCLIENTE
                    }
                );
            }
        }
        if(rowPopup.IDTPENDECLIE){
            dataSourceFilter.push(
                {
                    "name": "IDTPENDECLIE",
                    "operator": "=",
                    "value": rowPopup.IDTPENDECLIE
                }
            );
        }
        
        if (rowPopup.CDPAIS !== undefined){
            if(rowPopup.CDPAIS.length != 0){
                dataSourceFilter.push(
                    {
                        "name": "CDPAIS",
                        "operator": "IN",
                        "value": rowPopup.CDPAIS
                    }
                );
            }
            
        }
        
        if(rowPopup.SGESTADO !== undefined){
            if(rowPopup.SGESTADO.length != 0){
                dataSourceFilter.push(
                    {
                        "name": "SGESTADO",
                        "operator": "IN",
                        "value": rowPopup.SGESTADO
                    }
                );
            }
        }
        
        if(rowPopup.CDMUNICIPIO !== undefined){
            if(rowPopup.CDMUNICIPIO.length != 0){
                dataSourceFilter.push(
                    {
                        "name": "CDMUNICIPIO",
                        "operator": "IN",
                        "value": rowPopup.CDMUNICIPIO
                    }
                );
            }
        }
        
        if (rowPopup.CDATIVCLI != undefined){
            if(rowPopup.CDATIVCLI != ''){
                dataSourceFilter.push(
                    {
                        "name": "CDATIVCLI",
                        "operator": "=",
                        "value": rowPopup.CDATIVCLI
                    }
                );
            }
        }
        if (rowPopup.CDSEGMER != undefined){
            if (rowPopup.CDSEGMER != ''){
                dataSourceFilter.push(
                    {
                        "name": "CDSEGMER",
                        "operator": "=",
                        "value": rowPopup.CDSEGMER
                    }
                );
                
            }
        }
        
        if(rowPopup.CDROTATRANSPED != undefined){
            if( rowPopup.CDROTATRANSPED !=''){
                dataSourceFilter.push(
                    {
                        "name": "CDROTATRANSPED",
                        "operator": "=",
                        "value": rowPopup.CDROTATRANSPED
                    }
                );
            }
        }
        
        if(rowPopup.NRINSJURTRAN != undefined){
            if(rowPopup.NRINSJURTRAN !=''){
                dataSourceFilter.push(
                    {
                        "name": "NRINSJURTRAN",
                        "operator": "=",
                        "value": rowPopup.NRINSJURTRAN
                    }
                );
            }
        }
        
        if (rowPopup.CDTIPTRANS != undefined){
            if( rowPopup.CDTIPTRANS !=''){
                dataSourceFilter.push(
                    {
                        "name": "CDTIPTRANS",
                        "operator": "=",
                        "value": rowPopup.CDTIPTRANS
                    }
                );
            }
        }
        
        if (rowPopup.IDPGFRETTRAN != undefined){
            dataSourceFilter.push(
                {
                    "name": "IDPGFRETTRAN",
                    "operator": "=",
                    "value": rowPopup.IDPGFRETTRAN
                }
            );
            
        }
        
        if (rowPopup.CDTIPORECE != undefined){
            if(rowPopup.CDTIPORECE !=''){
                dataSourceFilter.push(
                    {
                        "name": "CDTIPORECE",
                        "operator": "=",
                        "value": rowPopup.CDTIPORECE
                    }
                );
            }
        }
        
        if (rowPopup.CDMODPGTO != undefined){
            if(rowPopup.CDMODPGTO !='' ){
                dataSourceFilter.push(
                    {
                        "name": "CDMODPGTO",
                        "operator": "=",
                        "value": rowPopup.CDMODPGTO
                    }
                );
            }
        }
        General.callRestEngine("ped#/crud/parampedido", 'FilterData', [{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function (success){
            if((rowPopup.CDVENDEDOR != undefined && !readonlyVendedor) || 
            (rowPopup.CDVENDEDOR != undefined && rowPopup.CDVENDEDOR != "" && readonlyVendedor) ||
            (rowPopup.CDVENDEDOR != undefined && success.dataset.parampedido[0].IDEXIBPEDIDO == "1")||
            (success.dataset.parampedido[0].IDEXIBPEDIDO == "2" && !readonlyVendedor)){
                
                args.owner.dataSourceFilter = dataSourceFilter;
        
                args.owner.container.getWidget('widgetRelatorioCustomizavelPedidoItem').reload();
            }else{
                ScreenService.showMessage('Operador não relacionado a um vendedor.');
            }
        });
    };

    
    this.setVendedor = function(widget, rowsToSet, cdOperador){
        var filter = [];
        if(cdOperador){
           filter.push(
                {
                    "name": "CDOPERADOR",
                    "operator": "=",
                    "value": cdOperador
                }
            );
        }else{
            filter.push(
                {
                    "name": "CDVENDEDOR",
                    "operator": "=",
                    "value": widget.currentRow.CDVENDEDOR
                }
            );
        }
        
        General.callRestEngine("ped#/crud/vendedor", 'FilterData', filter).then(function (success){
            var vendedor = success.dataset.vendedor[0];
            if(templateManager.container.getActiveWidget().getField('NMFANVEN').readOnly){
                if(success.dataset.vendedor.length > 0){
                    templateManager.container.getActiveWidget().currentRow.CDVENDEDOR = vendedor.CDVENDEDOR;
                    templateManager.container.getActiveWidget().currentRow.NMFANVEN = vendedor.NMFANVEN;

                }else{
                    ScreenService.closePopup();
                    ScreenService.showMessage('Operador não relacionado a um vendedor.');
                }
            }
  
           General.callRestEngine("ped#/crud/parampedido", 'FilterData',[{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function (callback){

                if(success.dataset.vendedor.length > 0 && rowsToSet){
                    templateManager.container.getActiveWidget().currentRow.CDVENDEDOR = vendedor.CDVENDEDOR;
                        templateManager.container.getActiveWidget().currentRow.NMFANVEN = vendedor.NMFANVEN;
                }else if(success.dataset.vendedor.length > 0){
                    templateManager.container.getActiveWidget().currentRow.CDVENDEDOR = vendedor.CDVENDEDOR;
                        templateManager.container.getActiveWidget().currentRow.NMFANVEN = vendedor.NMFANVEN;
                }else if(rowsToSet != undefined && callback.dataset.parampedido[0].IDEXIBPEDIDO == '2'){
                    ScreenService.showMessage('Operador não relacionado a um vendedor.');
                }
                //verifica se o parametro de relação entre cliente_vendedor está ativo
                if(templateManager.container.getWidget('widgetRelatorioCustomizavelPedidoItem').getField('CDVENDEDOR').IDUTRELACVENDCLI_AUX == 'S'){
                    if(rowsToSet ){
                        this.setCliente_Vendedor(widget,rowsToSet,rowsToSet.CDVENDEDOR);
                    }
                }else{
                    
                    var clienteAtivo = [{
                        
                        "name": "IDCLIEATIV",
                        "operator": "=",
                        "value": "S"
                        
                    }];
                    
    
                    templateManager.container.getWidget('widgetRelatorioCustomizavelPedidoItem').getField('NMRAZSOCCLIE').dataSource.name = 'ped#/crud/cliente';
                    templateManager.container.getWidget('widgetRelatorioCustomizavelPedidoItem').getField('NMRAZSOCCLIE').dataSourceFilter = clienteAtivo;
                    templateManager.container.getWidget('widgetRelatorioCustomizavelPedidoItem').getField('NMRAZSOCCLIE').reload();
                    
                
                    if(!templateManager.container.getActiveWidget().getField('CDVENDEDOR').readOnly && widget.currentRow.CDVENDEDOR){
                        ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
        
                    }
                    
            }
           }.bind(this));
        }.bind(this));
    };
    
    this.setDataSourceFilterField = function(field) {
        var widget = field.widget;
        if(field.name == 'SGESTADO'){
            
            var cdpais = widget.currentRow.CDPAIS;
            
            widget.getField('SGESTADO').dataSourceFilter[0].value = cdpais;
            widget.getField('SGESTADO').reload();
            
        }else if(field.name == 'CDMUNICIPIO'){
            
            var sgestado = widget.currentRow.SGESTADO;
            
            widget.getField('CDMUNICIPIO').dataSourceFilter[0].value = sgestado;
            widget.getField('CDMUNICIPIO').reload();
        }
    };
    
    this.clearDataField = function(fieldName, widget){
        var filterWidget = templateManager.container.getActiveWidget();
      
            if(fieldName == 'CDPAIS'){
                if(widget.currentRow.CDPAIS && widget.currentRow.CDPAIS.length > 0){
                    widget.getField("SGESTADO").readOnly = false;
                    
                }else{
                    widget.getField("SGESTADO").readOnly = true;
                    widget.getField("CDMUNICIPIO").readOnly = true;
                    filterWidget.currentRow.IDTPENDECLIE = 'P';
                    filterWidget.getField('IDTPENDECLIE').setValue('P');
                    
                    
                }
                widget.getField('SGESTADO').setValue([]);
                widget.getField('SGESTADO').reload();
                widget.getField('CDMUNICIPIO').setValue([]);
                widget.getField('CDMUNICIPIO').reload();
        
            }
            else if(fieldName == 'SGESTADO'){
                if (widget.currentRow.SGESTADO && widget.currentRow.SGESTADO.length > 0) {
                    widget.getField("CDMUNICIPIO").readOnly = false;
                } else {
                    widget.getField("CDMUNICIPIO").readOnly = true;
                }
                widget.getField('CDMUNICIPIO').setValue([]);
                widget.getField('CDMUNICIPIO').reload();

            }
    };
    this.prodIni = function(widget){
        var row = widget.currentRow;
        widget.getField('NMPRODFIN').readOnly = !row.NMPRODINI;
        widget.getField('NMPRODFIN').readOnlyOnEdit = !row.NMPRODINI;
        if(widget.getField('NMPRODFIN').readOnly == true){ 
            widget.currentRow.NMPRODFIN = "";
        }
        widget.reload();
        this.prodFin(widget);
        
    };
    this.prodFin = function(widget){

        var row = widget.currentRow;
        /*widget.dataSourceFilter = [
            {
                name: "P_NRORG",
                operator: "=",
                value: widgetWebservice.currentRow.NRORG
            },
            {
                name: "P_CDPRECOBASE",
                operator: "=",
                value: widgetWebservice.currentRow.CDPRECOBASE
            }
        ];*/
        if(row.NMPRODFIN){
            if(row.P_PRODINI > row.P_PRODFIN){
                ScreenService.showMessage("O codigo do produto inicial não pode ser maior que do final");
                return 0;
            }
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: row.P_PRODINI
                }
            );
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODFIN",
                    operator: "=",
                    value: row.P_PRODFIN
                }
            );
        } else {
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: "invalido"
                }
            );
        }
        widget.reload();
    };

    this.reloadDataSoure = function(args){
        args.owner.reload();
    };

    this.setFieldsGerais = function(widget){
        templateManager.container.fieldsGerais = widget.fields.map(function(field){return field.name;});
    };
   
}

Configuration(function(ContextRegister) {
	ContextRegister.register('Ped22000_relatorios_customizaveis_pedidos_itens_Controller', Ped22000_relatorios_customizaveis_pedidos_itens_Controller);
});